Index: /branches/OptimizationNetworks/HeuristicLab.Common.Resources/3.3/HeuristicLab.Common.Resources-3.3.csproj
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Common.Resources/3.3/HeuristicLab.Common.Resources-3.3.csproj	(revision 11711)
+++ /branches/OptimizationNetworks/HeuristicLab.Common.Resources/3.3/HeuristicLab.Common.Resources-3.3.csproj	(revision 11712)
@@ -444,4 +444,5 @@
     <None Include="Resources\VS2010ImageLibrary\VS2010ImageLibrary_Objects_Monitor_Large.png" />
     <None Include="Resources\VS2008ImageLibrary\VS2008ImageLibrary_Actions_DisplayInColor_Vertical.png" />
+    <Content Include="Resources\VS2008ImageLibrary\VS2008ImageLibrary_CommonElements_Objects_Arrow_Up_Down.png" />
     <Content Include="Resources\VS2008ImageLibrary\VS2008ImageLibrary_Objects_BatchRun_Paused.png" />
     <Content Include="Resources\VS2008ImageLibrary\VS2008ImageLibrary_Objects_BatchRun_Prepared.png" />
Index: /branches/OptimizationNetworks/HeuristicLab.Common.Resources/3.3/VSImageLibrary.Designer.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Common.Resources/3.3/VSImageLibrary.Designer.cs	(revision 11711)
+++ /branches/OptimizationNetworks/HeuristicLab.Common.Resources/3.3/VSImageLibrary.Designer.cs	(revision 11712)
@@ -104,4 +104,14 @@
         ///   Looks up a localized resource of type System.Drawing.Bitmap.
         /// </summary>
+        public static System.Drawing.Bitmap ArrowUpDown {
+            get {
+                object obj = ResourceManager.GetObject("ArrowUpDown", resourceCulture);
+                return ((System.Drawing.Bitmap)(obj));
+            }
+        }
+        
+        /// <summary>
+        ///   Looks up a localized resource of type System.Drawing.Bitmap.
+        /// </summary>
         public static System.Drawing.Bitmap Assembly {
             get {
Index: /branches/OptimizationNetworks/HeuristicLab.Common.Resources/3.3/VSImageLibrary.resx
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Common.Resources/3.3/VSImageLibrary.resx	(revision 11711)
+++ /branches/OptimizationNetworks/HeuristicLab.Common.Resources/3.3/VSImageLibrary.resx	(revision 11712)
@@ -524,3 +524,6 @@
     <value>Resources\VS2010ImageLibrary\camera.png;System.Drawing.Bitmap, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
   </data>
+  <data name="ArrowUpDown" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>Resources\VS2008ImageLibrary\VS2008ImageLibrary_CommonElements_Objects_Arrow_Up_Down.png;System.Drawing.Bitmap, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  </data>
 </root>
Index: /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/Message.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/Message.cs	(revision 11711)
+++ /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/Message.cs	(revision 11712)
@@ -29,5 +29,5 @@
   public class Message : Item, IMessage {
     public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.Field; }
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Comment; }
     }
 
Index: /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/Port.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/Port.cs	(revision 11711)
+++ /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/Port.cs	(revision 11712)
@@ -29,5 +29,5 @@
   public abstract class Port : NetworkItem, IPort {
     public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.Field; }
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Interface; }
     }
 
Index: /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/PortParameter.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/PortParameter.cs	(revision 11711)
+++ /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/PortParameter.cs	(revision 11712)
@@ -35,5 +35,5 @@
       get {
         if (Type.HasFlag(PortParameterType.Input) && Type.HasFlag(PortParameterType.Output))
-          return HeuristicLab.Common.Resources.VSImageLibrary.Field;
+          return HeuristicLab.Common.Resources.VSImageLibrary.ArrowUpDown;
         else if (Type.HasFlag(PortParameterType.Input))
           return HeuristicLab.Common.Resources.VSImageLibrary.ArrowDown;
@@ -41,5 +41,5 @@
           return HeuristicLab.Common.Resources.VSImageLibrary.ArrowUp;
         else
-          return base.ItemImage;
+          return base.ItemImage; ;
       }
     }
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPConnector.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPConnector.cs	(revision 11711)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPConnector.cs	(revision 11712)
@@ -24,5 +24,4 @@
 using HeuristicLab.Networks.Programmable;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using System.Drawing;
 
 namespace HeuristicLab.Networks {
@@ -30,8 +29,4 @@
   [StorableClass]
   public class KSPTSPConnector : ProgrammableNode {
-    public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.RadialChart; }
-    }
-
     protected override string CodeTemplate {
       get { return ReadCodeTemplate("HeuristicLab.Networks.KSPTSPConnectorCode.cs"); }
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPConnectorCode.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPConnectorCode.cs	(revision 11711)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPConnectorCode.cs	(revision 11712)
@@ -27,5 +27,4 @@
 using HeuristicLab.Networks.Programmable;
 using HeuristicLab.Problems.TravelingSalesman;
-using System.Drawing;
 using System.Linq;
 using System.Threading;
@@ -34,8 +33,4 @@
   [Item("KSPTSPConnector", "A node of an optimization network which connects a KSP and a TSP.")]
   public class CompiledKSPTSPConnector : ProgrammableNode.CompiledProgrammableNode {
-    public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.RadialChart; }
-    }
-
     protected CompiledKSPTSPConnector(CompiledKSPTSPConnector original, Cloner cloner) : base(original, cloner) { }
     public CompiledKSPTSPConnector(ProgrammableNode context)
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPNetwork.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPNetwork.cs	(revision 11711)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPNetwork.cs	(revision 11712)
@@ -24,5 +24,4 @@
 using HeuristicLab.Networks.Programmable;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using System.Drawing;
 
 namespace HeuristicLab.Networks {
@@ -31,8 +30,4 @@
   [StorableClass]
   public class KSPTSPNetwork : ProgrammableNetwork {
-    public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.Module; }
-    }
-
     protected override string CodeTemplate {
       get { return ReadCodeTemplate("HeuristicLab.Networks.KSPTSPNetworkCode.cs"); }
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPNetworkCode.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPNetworkCode.cs	(revision 11711)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPNetworkCode.cs	(revision 11712)
@@ -32,5 +32,4 @@
 using HeuristicLab.Problems.Knapsack;
 using HeuristicLab.Problems.TravelingSalesman;
-using System.Drawing;
 using System.Linq;
 
@@ -38,8 +37,4 @@
   [Item("KSPTSPNetwork", "An optimization network which connects a KSP and a TSP.")]
   public class CompiledKSPTSPNetwork : ProgrammableNetwork.CompiledProgrammableNetwork {
-    public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.Module; }
-    }
-
     protected CompiledKSPTSPNetwork(CompiledKSPTSPNetwork original, Cloner cloner) : base(original, cloner) { }
     public CompiledKSPTSPNetwork(ProgrammableNetwork context)
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/ProgrammableNetwork.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/ProgrammableNetwork.cs	(revision 11711)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/ProgrammableNetwork.cs	(revision 11712)
@@ -25,4 +25,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using System.Collections.Generic;
+using System.Drawing;
 using System.Linq;
 
@@ -31,4 +32,8 @@
   [StorableClass]
   public abstract class ProgrammableNetwork : ProgrammableNode, IProgrammableNetwork, IStorableContent {
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Module; }
+    }
+
     #region IStorableContent Members
     public string Filename { get; set; }
@@ -84,4 +89,8 @@
     [Item("CompiledProgrammableNetwork", "Abstract base class for compiled programmable networks.")]
     public abstract class CompiledProgrammableNetwork : CompiledProgrammableNode, INetwork {
+      public static new Image StaticItemImage {
+        get { return HeuristicLab.Common.Resources.VSImageLibrary.Module; }
+      }
+
       #region Network Members
       public override IEnumerable<INetworkItem> Children {
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/ProgrammableNetworkItem.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/ProgrammableNetworkItem.cs	(revision 11711)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/ProgrammableNetworkItem.cs	(revision 11712)
@@ -40,5 +40,5 @@
   public abstract class ProgrammableNetworkItem : Item, IProgrammableNetworkItem {
     public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.Script; }
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Class; }
     }
 
@@ -292,5 +292,5 @@
     public abstract class CompiledProgrammableNetworkItem : Item, INetworkItem {
       public static new Image StaticItemImage {
-        get { return HeuristicLab.Common.Resources.VSImageLibrary.Script; }
+        get { return HeuristicLab.Common.Resources.VSImageLibrary.Class; }
       }
 
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/ProgrammableNode.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/ProgrammableNode.cs	(revision 11711)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/ProgrammableNode.cs	(revision 11712)
@@ -25,4 +25,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using System.Collections.Generic;
+using System.Drawing;
 using System.Linq;
 using System.Threading;
@@ -32,4 +33,8 @@
   [StorableClass]
   public abstract class ProgrammableNode : ProgrammableNetworkItem, IProgrammableNode {
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.RadialChart; }
+    }
+
     #region Node Members
     new public INetwork Parent {
@@ -89,4 +94,8 @@
     [Item("CompiledProgrammableNode", "Abstract base class for compiled programmable nodes of a network.")]
     public abstract class CompiledProgrammableNode : CompiledProgrammableNetworkItem, INode {
+      public static new Image StaticItemImage {
+        get { return HeuristicLab.Common.Resources.VSImageLibrary.RadialChart; }
+      }
+
       #region Node Members
       new public INetwork Parent {
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/UserDefinedNetwork.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/UserDefinedNetwork.cs	(revision 11711)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/UserDefinedNetwork.cs	(revision 11712)
@@ -24,4 +24,5 @@
 using HeuristicLab.Core.Networks;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using System.Drawing;
 
 namespace HeuristicLab.Networks.Programmable {
@@ -30,4 +31,8 @@
   [StorableClass]
   public sealed class UserDefinedNetwork : ProgrammableNetwork, IUserDefinedNetwork {
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Script; }
+    }
+
     new public PortCollection Ports {
       get { return base.Ports; }
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/UserDefinedNode.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/UserDefinedNode.cs	(revision 11711)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/UserDefinedNode.cs	(revision 11712)
@@ -24,4 +24,5 @@
 using HeuristicLab.Core.Networks;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using System.Drawing;
 
 namespace HeuristicLab.Networks.Programmable {
@@ -29,4 +30,8 @@
   [StorableClass]
   public sealed class UserDefinedNode : ProgrammableNode, IUserDefinedNode {
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Script; }
+    }
+
     new public PortCollection Ports {
       get { return base.Ports; }