Index: /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/MessageCollection.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/MessageCollection.cs	(revision 11712)
+++ /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/MessageCollection.cs	(revision 11713)
@@ -26,5 +26,5 @@
 namespace HeuristicLab.Core.Networks {
   [StorableClass]
-  [Item("MessageCollection", "Represents a collection of messages.")]
+  [Item("MessageCollection", "A collection of messages.")]
   public class MessageCollection : ItemCollection<IMessage> {
     [StorableConstructor]
Index: /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/MessageValueCollection.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/MessageValueCollection.cs	(revision 11712)
+++ /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/MessageValueCollection.cs	(revision 11713)
@@ -26,5 +26,5 @@
 namespace HeuristicLab.Core.Networks {
   [StorableClass]
-  [Item("MessageValueCollection", "Represents a collection of message values.")]
+  [Item("MessageValueCollection", "A collection of message values.")]
   public class MessageValueCollection : KeyedItemCollection<string, IMessageValue> {
     [StorableConstructor]
Index: /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/NodeCollection.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/NodeCollection.cs	(revision 11712)
+++ /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/NodeCollection.cs	(revision 11713)
@@ -26,5 +26,5 @@
 namespace HeuristicLab.Core.Networks {
   [StorableClass]
-  [Item("NodeCollection", "Represents a collection of optimization network nodes.")]
+  [Item("NodeCollection", "A collection of network nodes.")]
   public class NodeCollection : NamedItemCollection<INode> {
     [StorableConstructor]
Index: /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/ParameterizedPort.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/ParameterizedPort.cs	(revision 11712)
+++ /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/ParameterizedPort.cs	(revision 11713)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.Core.Networks {
-  [Item("ParameterizedPort", "An abstract base class for parameterized ports of optimization network nodes.")]
+  [Item("ParameterizedPort", "Abstract base class for parameterized ports of network nodes.")]
   [StorableClass]
   public abstract class ParameterizedPort : Port, IParameterizedPort {
Index: /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/Port.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/Port.cs	(revision 11712)
+++ /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/Port.cs	(revision 11713)
@@ -25,5 +25,5 @@
 
 namespace HeuristicLab.Core.Networks {
-  [Item("Port", "Abstract base class for ports of an optimization network node.")]
+  [Item("Port", "Abstract base class for ports of network nodes.")]
   [StorableClass]
   public abstract class Port : NetworkItem, IPort {
Index: /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/PortCollection.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/PortCollection.cs	(revision 11712)
+++ /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/PortCollection.cs	(revision 11713)
@@ -26,5 +26,5 @@
 namespace HeuristicLab.Core.Networks {
   [StorableClass]
-  [Item("PortCollection", "Represents a collection of ports in an optimization network node.")]
+  [Item("PortCollection", "A collection of ports of a network node.")]
   public class PortCollection : NamedItemCollection<IPort> {
     [StorableConstructor]
Index: /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/PortParameterCollection.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/PortParameterCollection.cs	(revision 11712)
+++ /branches/OptimizationNetworks/HeuristicLab.Core/3.3/Networks/PortParameterCollection.cs	(revision 11713)
@@ -26,5 +26,5 @@
 namespace HeuristicLab.Core.Networks {
   [StorableClass]
-  [Item("PortParameterCollection", "Represents a collection of port parameters.")]
+  [Item("PortParameterCollection", "A collection of port parameters.")]
   public class PortParameterCollection : NamedItemCollection<IPortParameter> {
     [StorableConstructor]
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/AlgorithmNode.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/AlgorithmNode.cs	(revision 11712)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/AlgorithmNode.cs	(revision 11713)
@@ -32,5 +32,5 @@
 
 namespace HeuristicLab.Networks {
-  [Item("AlgorithmNode", "A node of an optimization network which contains a HeuristicLab algorithm.")]
+  [Item("AlgorithmNode", "A node of a network which contains a HeuristicLab algorithm.")]
   [StorableClass]
   public class AlgorithmNode : Node, IAlgorithmNode {
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/ConfigurationPort.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/ConfigurationPort.cs	(revision 11712)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/ConfigurationPort.cs	(revision 11713)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.Networks {
-  [Item("ConfigurationPort", "A port of an optimization network node which triggers configuration changes.")]
+  [Item("ConfigurationPort", "A port of a network node which triggers configuration changes.")]
   [StorableClass]
   public class ConfigurationPort : MessagePort, IConfigurationPort {
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/ExecutionPort.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/ExecutionPort.cs	(revision 11712)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/ExecutionPort.cs	(revision 11713)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.Networks {
-  [Item("ExecutionPort", "A port of an optimization network node which triggers execution.")]
+  [Item("ExecutionPort", "A port of a network node which triggers execution.")]
   [StorableClass]
   public class ExecutionPort : MessagePort, IExecutionPort {
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPNetwork.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPNetwork.cs	(revision 11712)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPNetwork.cs	(revision 11713)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.Networks {
-  [Item("KSPTSPNetwork", "An optimization network which connects a KSP and a TSP.")]
+  [Item("KSPTSPNetwork", "An optimization network which contains a KSP and a TSP.")]
   [Creatable("Optimization Networks")]
   [StorableClass]
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPNetworkCode.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPNetworkCode.cs	(revision 11712)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/KSPTSPNetworkCode.cs	(revision 11713)
@@ -35,5 +35,5 @@
 
 namespace HeuristicLab.Networks {
-  [Item("KSPTSPNetwork", "An optimization network which connects a KSP and a TSP.")]
+  [Item("KSPTSPNetwork", "An optimization network which contains a KSP and a TSP.")]
   public class CompiledKSPTSPNetwork : ProgrammableNetwork.CompiledProgrammableNetwork {
     protected CompiledKSPTSPNetwork(CompiledKSPTSPNetwork original, Cloner cloner) : base(original, cloner) { }
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/UserDefinedNetwork.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/UserDefinedNetwork.cs	(revision 11712)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/UserDefinedNetwork.cs	(revision 11713)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.Networks.Programmable {
-  [Item("User-Defined Network", "A network which can be defined by the user.")]
+  [Item("User-Defined Network", "A network which can be defined and programmed by the user.")]
   [Creatable("Optimization Networks")]
   [StorableClass]
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/UserDefinedNode.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/UserDefinedNode.cs	(revision 11712)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/Programmable/UserDefinedNode.cs	(revision 11713)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.Networks.Programmable {
-  [Item("User-Defined Node", "A node of a network which can be defined by the user.")]
+  [Item("User-Defined Node", "A node of a network which can be defined and programmed by the user.")]
   [StorableClass]
   public sealed class UserDefinedNode : ProgrammableNode, IUserDefinedNode {