Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/ConfigurationPort.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/ConfigurationPort.cs	(revision 11713)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/ConfigurationPort.cs	(revision 11714)
@@ -22,11 +22,10 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Core.Networks;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Networks {
-  [Item("ConfigurationPort", "A port of a network node which triggers configuration changes.")]
+  [Item("ConfigurationPort", "A port of a network node which triggers configuration changes and can be defined by the user.")]
   [StorableClass]
-  public class ConfigurationPort : MessagePort, IConfigurationPort {
+  public class ConfigurationPort : UserDefinedMessagePort, IConfigurationPort {
     [StorableConstructor]
     protected ConfigurationPort(bool deserializing) : base(deserializing) { }
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/ExecutionPort.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/ExecutionPort.cs	(revision 11713)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/ExecutionPort.cs	(revision 11714)
@@ -22,11 +22,10 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Core.Networks;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Networks {
-  [Item("ExecutionPort", "A port of a network node which triggers execution.")]
+  [Item("ExecutionPort", "A port of a network node which triggers execution and can be defined by the user.")]
   [StorableClass]
-  public class ExecutionPort : MessagePort, IExecutionPort {
+  public class ExecutionPort : UserDefinedMessagePort, IExecutionPort {
     [StorableConstructor]
     protected ExecutionPort(bool deserializing) : base(deserializing) { }
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/IConfigurationPort.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/IConfigurationPort.cs	(revision 11713)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/IConfigurationPort.cs	(revision 11714)
@@ -20,7 +20,6 @@
 #endregion
 
-using HeuristicLab.Core.Networks;
 
 namespace HeuristicLab.Networks {
-  public interface IConfigurationPort : IMessagePort { }
+  public interface IConfigurationPort : IUserDefinedMessagePort { }
 }
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/IExecutionPort.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/IExecutionPort.cs	(revision 11713)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/IExecutionPort.cs	(revision 11714)
@@ -20,7 +20,6 @@
 #endregion
 
-using HeuristicLab.Core.Networks;
 
 namespace HeuristicLab.Networks {
-  public interface IExecutionPort : IMessagePort { }
+  public interface IExecutionPort : IUserDefinedMessagePort { }
 }
Index: /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/UserDefinedMessagePort.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/UserDefinedMessagePort.cs	(revision 11713)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks/3.3/UserDefinedMessagePort.cs	(revision 11714)
@@ -28,5 +28,5 @@
   [Item("User-Defined Message Port", "A message port of a network which can be defined by the user.")]
   [StorableClass]
-  public sealed class UserDefinedMessagePort : MessagePort, IUserDefinedMessagePort {
+  public class UserDefinedMessagePort : MessagePort, IUserDefinedMessagePort {
     new public PortParameterCollection Parameters {
       get { return base.Parameters; }
@@ -34,6 +34,6 @@
 
     [StorableConstructor]
-    private UserDefinedMessagePort(bool deserializing) : base(deserializing) { }
-    private UserDefinedMessagePort(UserDefinedMessagePort original, Cloner cloner) : base(original, cloner) { }
+    protected UserDefinedMessagePort(bool deserializing) : base(deserializing) { }
+    protected UserDefinedMessagePort(UserDefinedMessagePort original, Cloner cloner) : base(original, cloner) { }
     public UserDefinedMessagePort() : base("UserDefinedMessagePort") { }
     public UserDefinedMessagePort(string name) : base(name) { }