Index: branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Encodings/Encoding.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Encodings/Encoding.cs	(revision 11733)
+++ branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Encodings/Encoding.cs	(revision 11737)
@@ -80,6 +80,7 @@
     }
 
+    public void ConfigureOperator(IOperator @operator) { ConfigureOperators(new[] { @operator }); }
     public abstract void ConfigureOperators(IEnumerable<IOperator> operators);
-    public void ConfigureOperator(IOperator @operator) { ConfigureOperators(new[] { @operator }); }
+
 
     public event EventHandler SolutionCreatorChanged;
@@ -89,11 +90,4 @@
       if (handler != null) handler(this, EventArgs.Empty);
     }
-
-
-    public event EventHandler ParameterConfigurationChanged;
-    protected virtual void OnParameterConfigurationChanged() {
-      var handler = ParameterConfigurationChanged;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
   }
 }
Index: branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Individuals/Individual.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Individuals/Individual.cs	(revision 11733)
+++ branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Individuals/Individual.cs	(revision 11737)
@@ -29,5 +29,5 @@
 namespace HeuristicLab.Problems.Programmable {
   public abstract class Individual {
-    public IEncoding Encoding { get; private set; }
+    protected IEncoding Encoding { get; private set; }
     protected IScope Scope { get; private set; }
 
Index: branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Individuals/MultiEncodingIndividual.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Individuals/MultiEncodingIndividual.cs	(revision 11733)
+++ branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Individuals/MultiEncodingIndividual.cs	(revision 11737)
@@ -27,9 +27,10 @@
 namespace HeuristicLab.Problems.Programmable {
   public sealed class MultiEncodingIndividual : Individual {
-    public new MultiEncoding Encoding {
+    private new MultiEncoding Encoding {
       get { return (MultiEncoding)base.Encoding; }
     }
 
     private readonly IEnumerable<Individual> individuals;
+
     public MultiEncodingIndividual(MultiEncoding encoding, IScope scope)
       : base(encoding, scope) {
Index: branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Interfaces/IEncoding.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Interfaces/IEncoding.cs	(revision 11733)
+++ branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Interfaces/IEncoding.cs	(revision 11737)
@@ -30,5 +30,4 @@
 
     IEnumerable<IOperator> Operators { get; }
-    //event EventHandler ParameterConfigurationChanged;
 
     Individual GetIndividual(IScope scope);
@@ -37,5 +36,4 @@
 
     event EventHandler SolutionCreatorChanged;
-    //event EventHandler OperatorsChanged;
   }
 }
Index: branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/MultiEncodingOperator.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/MultiEncodingOperator.cs	(revision 11733)
+++ branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/MultiEncodingOperator.cs	(revision 11737)
@@ -53,5 +53,5 @@
     }
 
-    public IConstrainedValueParameter<T> GetParameter(IEncoding encoding) {
+    protected IConstrainedValueParameter<T> GetParameter(IEncoding encoding) {
       if (!Parameters.ContainsKey(encoding.Name)) throw new ArgumentException(string.Format("Encoding {0} was not added to the MultiEncoding.", encoding.Name));
 